/*
	Copyright (c) 2006-2007, ePages GmbH
	All Rights Reserved.
*/
dojo.provide("epages.widget.TypedWidget");
dojo.require("epages.widget");
dojo.require("dijit._Widget");
dojo.require("dijit._Templated");

dojo.declare("epages.widget.TypedWidget", [dijit._Widget, dijit._Templated], {
	// summary : Base class for all widgets which can select template via templateType
	_templateDirectory: undefined,
	postMixInProperties: function() {
		this.inherited("postMixInProperties", arguments);
		if (this._templateMapping !== undefined &&  this.templateType !== undefined &&  this._templateDirectory !== undefined) {
			if(this._templateMapping[this.templateType]!==undefined) {
				// check if set to widget's default using its prototype value
				if(this.templateType != this.defaultTemplateType) {
					var tempPath = '';

					// load templates from json object..
					if(typeof this._templateMapping[this.templateType] == 'object'){
						var TempObj = this._templateMapping[this.templateType];

						// ..from shrinksafed packages
						if(TempObj.templateString){
								this.templatePath   = null;
								this.templateString = TempObj.templateString;
						}

						// ..from sources
						else if(TempObj.templatePath){
							var TempTemplateString;
							dojo.xhrGet({
								url: TempObj.templatePath,
								sync: true,
								load: function(data){
									TempTemplateString = data;
								}
							});
							this.templatePath   = null;
							this.templateString = TempTemplateString;
						} else {
								console.warn('Template type: "'+ this.templateType +'" could not be loaded from json object! Use properties templatePath or templateString to declare its template file!');
						}
					}

					// backward compatibility mode: load templates from old non object format
					else {
							tempPath = this._templateDirectory;
							tempPath.path       += '/'+this._templateMapping[this.templateType];
							tempPath.uri        += '/'+this._templateMapping[this.templateType];
							this.templatePath   = tempPath;
							this.templateString = null;
					}
				}
			} else {
				console.warn('Template type: "'+ this.templateType +'" does not exist in this widget - use default. ('+this.declaredClass+')');
			}
		}
	}

});

